"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDecoys = void 0;
const error_1 = require("./error");
const utils_1 = require("@sd-jwt/utils");
const createDecoys = (count, saltGenerator, hasherAndAlgorithm) => __awaiter(void 0, void 0, void 0, function* () {
    if (count < 0) {
        throw new error_1.SdJwtError(`Negative count of ${count} is not allowed.`);
    }
    if (isNaN(count)) {
        throw new error_1.SdJwtError(`NaN is not allowed for count.`);
    }
    if (!isFinite(count)) {
        throw new error_1.SdJwtError(`Infinite is not allopwed for count.`);
    }
    const decoys = [];
    for (let i = 0; i < count; i++) {
        const salt = yield saltGenerator();
        const decoy = yield hasherAndAlgorithm.hasher(salt, hasherAndAlgorithm.algorithm);
        const encodedDecoy = utils_1.Base64url.encode(decoy);
        decoys.push(encodedDecoy);
    }
    return decoys;
});
exports.createDecoys = createDecoys;
//# sourceMappingURL=decoys.js.map